package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID            = "uid"
	NAME           = "name"
	TYPE           = "type"
	ROLE           = "role"
	STATUS         = "status"
	TITLE          = "title"
	CONTENT        = "content"
	CREATOR        = "creator"
	USER_UID       = "user_uid"
	USER_AUTH_ROLE = "user_auth_role"
	AUTH_UID       = "auth_uid"
	AUTH_NAME      = "auth_name"
	AUTH_TYPE      = "auth_type"
	AUTH_STATUS    = "auth_status"
	CERT_UID       = "cert_uid"
	COMPANY_UID    = "company_uid"
	COMPANY_NAME   = "company_name"
	CITY_UID       = "city_uid"
	CITY_NAME      = "city_name"
	FROM_UID       = "from_uid"
)

type UserAuth struct {
	db.ModelUserPlace
	AuthUID string `gorm:"type:char(32);index"`
}
type Auth struct {
	db.ModelWithUID
	CompanyUID string `gorm:"type:char(32);index"`
	FromUID    string `gorm:"type:char(32);index"`
	Name       string `gorm:"type:varchar(64)"`
	Type       uint8  `gorm:"default:0"`
	Status     uint8  `gorm:"default:0"`
}
type Cert struct {
	db.ModelContent
	AuthUID string `gorm:"type:char(32);index"`
}

func init() { db.CmdModels("", &UserAuth{}, &Auth{}, &Cert{}) }
