package yuehaoxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type call struct {
	Schedule
	call   string `name:"call" help:"叫号" role:"worker"`
	list   string `name:"list queue_uid uid reception_uid auto" role:"worker"`
	expire string `name:"expire" role:"worker"`
	finish string `name:"finish" role:"worker"`
}

func (s call) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.SelectByStatus(m.Options(mdb.ORDER, model.TAKE_TIME), arg[0], kit.Format(ScheduleTake))
		kit.If(m.Length() == 0, func() { m.Echo(m.Trans("wait take", "等待取号")) }, func() { m.Action(s.Call) })
	} else if len(arg) == 2 {
		s.Schedule.List(m, arg[0], arg[1]).Action(s.Call)
	} else if len(arg) == 3 {
		s.Schedule.Select(m, model.QUEUE_UID, arg[0], model.RECEPTION_UID, arg[2], model.STATUS, kit.Format(ScheduleTake)).Action(s.Call)
	}
}

func init() { ice.TeamCtxCmd(call{}) }
